# Kentaro Fukumoto
# p. 128, Exercise 4.4(.4)

rm(list=ls())

# data
library(BaM) 
data(child)
attach(child)
y <- SCCOLL
n <- length(y)
x <- cbind(ACES,INSTABIL,AAMBIG,CSTAFF,ARD,ASLACK,AEXPEND)
data.Meier <- data <- list ("n", "y", "x") 

# initial values
in1 <- list(theta0=0,theta1=0,theta2=0,theta3=0,theta4=0,theta5=0,theta6=0,theta7=0,tau=1)
in2 <- list(theta0=0.01,theta1=0.01,theta2=0.01,theta3=0.01,theta4=0.01,theta5=0.01,theta6=0.01,theta7=0.01,tau=1.1)
in3 <- list(theta0=-0.01,theta1=-0.01,theta2=-0.01,theta3=-0.01,theta4=-0.01,theta5=-0.01,theta6=-0.01,theta7=-0.01,tau=0.9)
inits <- list(in1,in2,in3)

# parameters to be stored
parameters <- c("theta0", "theta1", "theta2", "theta3", "theta4", "theta5", "theta6", "theta7", "tau")

# estimation
library(R2WinBUGS) 
# WinBUGS
bugs.out <- bugs(data.Meier, inits, parameters, "model.Meier.r",
                 n.chains=3, n.iter=1000, program="winbugs",
                 bugs.directory="c:/Program Files/WinBUGS14/")
# OpenBUGS
#install.packages("BRugs")
bugs.out <- bugs(data.Meier, inits, parameters, "model.Meier.r",
                 n.chains=3, n.iter=1000, program="openbugs") 

# results
print(bugs.out,3)
plot(bugs.out) 
par(mfrow=c(2,5))
traceplot(as.mcmc(bugs.out$sims.matrix))

plot(bugs.out$sims.array[,1,1],type='n')
for(i in 1:3){
  par(new=T)
  lines(bugs.out$sims.array[,i,1],col=(i+1)) # [sample,chain,parameter]
}

