# Bayesian Method (2nd edition)
# written by Jeff Gill
# http://jgill.wustl.edu/BMSBSA2/

# R scripts in ch. 4
#  drafted by Taehee Kim commneted with single #
## revised by Kentaro Fukumoto commneted with double ##'s

##############################################################################
#            4.5 Compurational Addendum                                      #
#         4.5.1 Palm Beach Country Normal Model                              #
##############################################################################
#NOTE:                                                                       #
#{́AJeff GillChpter06t@CɃXNvgƃf[^܂B       #
#A{łuninformed.table, conjugate.table쐬ȂǈꕔXNvg #
#{ƈقȂ镔̂ŁA{Iɂ͖{(pp130-132)x[XɂĂ܂B     #
#܂AꕔG[oӏ͏CĂ܂iXNvg{QƁjB   @   #
##############################################################################

## write in Engish so that more people, including Jeff, can read it

# Returns a regression table with credible intervals
t.ci.table <- function(coefs,cov.mat,level=0.95,degrees=Inf,quantiles=c(0.025,0.500,0.975))  {
  quantile.mat <- cbind( coefs, sqrt(diag(cov.mat)), 
                         t(qt(quantiles,degrees) %o% sqrt(diag(cov.mat)))
                         + matrix(rep(coefs,length(quantiles)),ncol=length(quantiles)) )
  quantile.names <- c("Mean","Std. Error")
  for (i in 1:length(quantiles))
    quantile.names <- c(quantile.names,paste(quantiles[i],"Quantile"))
  dimnames(quantile.mat)[2] <- list(quantile.names)
  #return(title="Posterior Quantities",round(quantile.mat,4))
  return(list(title="Posterior Quantities",round(quantile.mat,4)))
  #return̂܂܂Ɖ͂̕ŃG[܂i"̌ʂԂ return ͋܂"jB̂߁AlistĂ܂B
  #ȉQƂ܂Bhttp://www.okada.jp.org/RWiki/?R%A4%CE%B4%D8%BF%F4%C4%EA%B5%C1%A4%CE%B4%F0%CB%DC#sd01cac7
}

# READ IN THE DATA AND SETUP UP THE BASIC DATA STRUCTURE
#data(pbc.vote)
#X <- cbind(tech, new, turnout, rep, whi);Y <- badballots
#library(nnet);library(mice)
#imp.X <- mice(X)
#X <- as.matrix(cbind(rep(1,nrow(X)), complete(imp.X)))

#BaMpbP[W̒ɂf[^܂AϐقȂȂǂĂ̂ŁAch06ɓĂf[^gp܂B
#́̕Ach06pbc.s̃f[^ǂݍݕgpĂ܂B
pbc.vote <- as.matrix(read.table("pbc.dat",sep=" "))#pbc.sł́AURLf[^̃_E[h悤ɂȂĂ̂ŏCB
dimnames(pbc.vote)[[2]] <- c("badballots", "tech", "new", "turnout", "rep", "whi")
X <- cbind(rep(1,nrow(pbc.vote)),pbc.vote[,-1]); Y <- pbc.vote[,1]

#Uniformed prior analysis
bhat <- solve(t(X)%*%X)%*%t(X)%*%Y
s2 <- t(Y-X%*%bhat)%*%(Y-X%*%bhat)/(nrow(X)-ncol(X))
R <- solve(t(X)%*%X)*((nrow(X)-ncol(X))*s2/(nrow(X)-ncol(X)-2))[1,1]
uninformed.table <- t.ci.table(bhat,R,degrees=nrow(X)-ncol(X))[[2]]
alpha <- (nrow(X)-ncol(X)-1)/2
beta <- 0.5*s2*(nrow(X)-ncol(X))
set.seed(14102013) ##
sort.inv.gamma.sample <- sort(1/rgamma(10000,alpha,beta))
sqrt.sort.inv.gamma.sample <- sqrt(sort.inv.gamma.sample)
uninformed.table <- rbind(uninformed.table,
                          c( mean(sqrt.sort.inv.gamma.sample),
                             sqrt(var(sqrt.sort.inv.gamma.sample)),
                             sqrt.sort.inv.gamma.sample[250],
                             sqrt.sort.inv.gamma.sample[5000],
                             sqrt.sort.inv.gamma.sample[9750]))

#Conjugate prior analysis
A <- 3; B <- 9; BBeta <- rep(0,6); Sigma <- diag(c(2,2,2,2,2,2))
tB <- solve(solve(Sigma) + t(X)%*%X) %*% (solve(Sigma)%*%BBeta + t(X)%*%X%*%bhat)
ts <- 2*B + s2*(nrow(X)-ncol(X)) + (t(BBeta)-t(tB))%*%
  solve(Sigma)%*%BBeta + t(bhat-tB)%*%t(X)%*%X%*%bhat
R <- diag(ts/(nrow(X)+A-ncol(X)-2))* solve(solve(Sigma)+t(X)%*%X)
conjugate.table <- t.ci.table(tB,R,degrees=nrow(X)+A-ncol(X)-3)[[2]]
alpha <- (nrow(X)-ncol(X)-1)/2
beta <- 0.5*s2*(nrow(X)-ncol(X))
set.seed(15102013) ##
sort.inv.gamma.sample <- sort(1/rgamma(10000,alpha,beta))
sqrt.sort.inv.gamma.sample <- sqrt(sort.inv.gamma.sample)
conjugate.table <- rbind(conjugate.table,
                         c( mean(sqrt.sort.inv.gamma.sample),
                            sqrt(var(sqrt.sort.inv.gamma.sample)),
                            sqrt.sort.inv.gamma.sample[250],
                            sqrt.sort.inv.gamma.sample[5000],
                            sqrt.sort.inv.gamma.sample[9750]))

uninformed.table #ʂ
conjugate.table #ʂ
## definitely we need them!

