# Bayesian Method (2nd edition)
# written by Jeff Gill
# http://jgill.wustl.edu/BMSBSA2/

# R scripts in ch. 4
#  drafted by Tomoyuki Kano commneted with single #
## revised by Kentaro Fukumoto commneted with double ##'s

war <- read.csv("war in ancient china.csv", header = T)
wars <- na.omit(war)

## you may fail to install BaM as I did.
## if you succeed, the following script should work
library(BaM) ##
## data(wars)

X <- cbind(wars$EXTENT,wars$DIVERSE,wars$ALLIANCE,wars$DYADS,wars$TEMPOR,wars$DURATION)
y <- wars$SCOPE
n <- nrow(X); k <- ncol(X)
nu <- 5
num.sims <- 10000
war.samples <- matrix(NA,nrow=num.sims,(ncol=k+n+1))
beta <- rep(1,ncol(X));sigma.sq <- 3;Omega <- 3*diag(n)

set.seed(15102012) ##
date.begin <- date() ##
date.begin ## I'm so impatient
for(i in 1:num.sims) {
   b <- solve(t(X) %*% X) %*% t(X) %*% y
##   b.star <- solve(t(X) %*% Omega %*% X) %*% t(X) 
##       %*% Omega %*% y
   b.star <- solve(t(X) %*% Omega %*% X) %*% t(X) %*% Omega %*% y ##
## an operator should come at the end of the line, not at its top
     ##Omega %*% y ##
   s.sq.star <- t(y-X%*%b) %*% solve(Omega) %*% (y-X%*%b)
   u <- y - X %*% beta
##   beta <- as.vector( rmultinorm(1, b.star, sigma.sq
##       *solve(t(X) %*% solve(Omega) %*% X)))
   beta <- as.vector( rmultnorm(1, b.star, sigma.sq* solve(t(X) %*% solve(Omega) %*% X)))## a wrong function name and 
## an operator should come at the end of the line, not at its top
                                 ##  solve(t(X) %*% solve(Omega) %*% X))) ##
   sigma.sq <- 1/rgamma(1,shape=(n-1)/2,rate=s.sq.star/2 )
   for (j in 1:n) Omega[j,j] <- 1/rgamma(1, shape=(nu+1)/2,
       rate=((sigma.sq^(-1))*u^2 + nu)/2 )
   war.samples[i,] <- c(beta,sigma.sq,diag(Omega))
   if(i%%1000==0){ ##
     print(paste(i,"of",num.sims,"iterations end at",date())) ## I'm so, so impatient
   } ##
}
date.end <- date() ##
date.begin ##
date.end ##

## below, all scripts are added by Kentaro Fukumoto

## why don't you see the results?
round(cbind(
apply(war.samples[,1:6],2,mean),
apply(war.samples[,1:6],2,sd),
t(apply(war.samples[,1:6],2,quantile,c(0.025,0.975)))
),4)
## something is wrong... with Kano's data or Jeff's data

par(mfrow=c(2,3))
for(v in 1:6){
  plot(war.samples[,v],type='l')
}
# well converged

for(v in 1:6){
  plot(war.samples[1:10,v],type='l')
}

burn.in <- -c(1:100)
plot(war.samples[burn.in,1],war.samples[burn.in,2])

